package FluxY_Lib::MS::ImportDataClass;

################################################################################
# This module provides support for importing a new data class from a tab
# separated specification file using a similar format to the data tables format
# generated by printing an analyte information table.
# - for complete details see the instruction guide for adding a new data class.
#
################################################################################

#use strict;
#use warnings;

use FluxY_Lib::Chemistry::atomInfo; # User Lib - Natural Abundance Probability.
use FluxY_Lib::Data::Data_Check;    # User Lib - Basic configuration data check.
use FluxY_Lib::IO::IO_Utils;        # User Lib - Provides I/O routines.

use base 'Exporter';

our @EXPORT = qw(ImportDataClass_GE);


################################################################################
# Subroutine: ImportDataClass_GE
#
# Reads in the data class information from the specified input file and
# uses that data to generates a generic data class module (DataClass_GE.pm).
#
################################################################################
sub ImportDataClass_GE{
   my ($dataFile, $path) = @_;

   &CheckFileName($dataFile, "specified at the command line");

   my @lines = &GenerateDataClassGE(&ReadFileSkipBC($dataFile));

   my $outFile = $path . "/FluxY_Lib/MS/DataClass_GE.pm";
   open (FILE, ">" . $outFile) or FileSystemError(900, $outFile, $!);

   foreach my $line (@lines) { print FILE $line; }
   
   close(FILE)                 or FileSystemError(901, $outFile, $!);
}


################################################################################
# Subroutine: GenerateDataClassGE
#
# The Main method to generate the GE data class.
#
################################################################################
sub GenerateDataClassGE {
   my @inLines = @_;
   
   # The minimum number of table columns is 6:
   # - Key, a unique abbreviated form of the analyte name,
   # - Num-C, the number of carbons in the fragmented backbone (used for OBM correction),
   # - Num-LE, the number of labeled atoms in the unfragmented backbone (used to generate EMU and cumomer data),
   # - Position-LE, the start and end position of the labeled elements
   # - Name, the full name of the analyte, and
   # - at least one element.
   $minHeadSize = 6;

   my $className = shift @inLines;
   my $classID   = shift @inLines;
   my $lElement  = shift @inLines;

   if ( &CheckElementSymbols($lElement) != 1 ) { &ImportError(880, @atomList); }

   my @header    = split(/\t/, shift @inLines );
   
   #Check that the table contains the minimum size.
   &CheckLLimit(scalar(@header), "which is the number of table header columns", $minHeadSize, "I");
   
   my @atomList = @header[1..(@header-5)];
   
   #Check each element in the atom list is a valid element.
   #Convert to Uppercase
   if ( &CheckElementSymbols(@atomList) != 1 ) { &ImportError(881, @atomList); }
   my $cPosition = -1;
   for (my $i=0; $i<@atomList; $i++) {
      if ( $atomList[$i] eq "C" ) { $cPosition = $i; }
      $atomList[$i] = "'" . uc($atomList[$i]) . "'";
   }
#NEED TO THROW ERROR IF cPosition<1
   
   my @outLines = &GetHeader1();
   
   push(@outLines, "my \@atomList = (" . join(',', @atomList) . ");\n");
   
   push(@outLines, &GetHeader2());
   
   for (my $i=1; $i<=@inLines; $i++) {
      my @data = split(/\t/, $inLines[$i-1] );
      
      #Check that each line has the same number of elements as the header.
      &CheckValue(scalar(@data), "of elements in table row $i", scalar(@header), "I");

      my $key        = lc(shift(@data));   # Converts the key to lower case as default.
      my $name       = pop(@data);      
      my @positionLE = split("-", pop(@data));
      my $numLE      = pop(@data);
      my $numCarbons = pop(@data);
      
      #Check That key starts with a letter.
      if ( $key !~ /^[[:lower:]]/ ) { &ImportError(885, $i, $key); }
      
      #Check the backbone position for the labeled element has the desired format.
      if ( @positionLE != 2 ) { &ImportError(886, $i); }
      &CheckLLimit($positionLE[0], "the lower backbone position limit in row $i", 1, "I");
      &CheckLLimit($positionLE[1], "the upper backbone position limit in row $i", 1, "I");
      if ( $positionLE[1] < $positionLE[0] ) { &ImportError(887, $i, @positionLE); }
      
      #Check that the number of labeled elements is an integer, and that it is 
      #not less than the upper value in the backbone position.
      &CheckLLimit($numLE, "the number of labeled elements in row $i", 1, "I");
      if ( $numLE < $positionLE[1] ) { &ImportError(888, $i, $numLE, @positionLE); }
      
      #Check that the number of carbons in the fragmented backbone is an integer,
      #and that it is not greater than the total number of carbons.
      &CheckLLimit($numCarbons, "the number of backbone carbons in row $i", 1, "I");
      if ( $numCarbons > $data[$cPosition] ) { &ImportError(889, $i, $numCarbons, $data[$cPosition]); }

      #Check that each element in the remaining data array is an integer.
      for (my $j=0; $j<@data; $j++) {
         &CheckLLimit($data[$j], "for the atom count in row $i column" . ($j+2), 0, "N");
      }

      push(@outLines, "   " . $key . " => [\"" . $name . "\", [" . join(',', @data) . "], [" . join(',', @positionLE) . "], " . $numLE . ", " . $numCarbons . "],\n");
   }
   
   push(@outLines, "   );\n\n");
   push(@outLines, "my \$lElement  = \"" . $lElement . "\";   # The labeling element used in the experiment.\n");
   push(@outLines, "my \$className = \"" . $className . "\";   # The name of the data class.\n");
   push(@outLines, "my \$printFile = \"GE-" . $classID . "_Data_Table.txt\";   # The name of the info table file.\n\n");

   push(@outLines, &GetMethods());

   return @outLines;
}


################################################################################
# Subroutine: GetHeader1
################################################################################
sub GetHeader1 {
   my $line = "package FluxY_Lib::MS::DataClass_GE;

################################################################################
# This class provides support for Generic Analytes.
# - This class represents an explicit set of derivatized fragments, listed
#   uniquely in the compounds list, with derivatizing information directly
#   integrated into the atom count. Additionally a third parameter is added to
#   each compound to directly specify the first and last position of the labeled
#   element for the fragmented backbone, a fourth to specify the number of
#   labeled elements in the unfragmented backbone and lastly the number of
#   carbons in the fragmented backbone.
# - The last item is redundant, but still required if the labeling is carbon.
# - Although a derivatized class, by explicitly listing the complete fragment
#   information it is implemented with the simpler compound class.
#
# This class inherits basic functionality from the CompoundClass parent class,
# initializing it with the compound name, the compounds table, the atom list and
# the specific labeling element, as defined by this class.
# - It overrides the GetNumFragmentedLabeledElement(), GetLabeledPositionString()
#   and PrintInfoTable() methods to make use of the specified first and last
#   labeled backbone positions in each compound array.
# - It overrides the GetNumLabeledElement() method to make use of the specified
#   number of labeled elements in the backbone of the unfragmented compound.
# - It overrides the GetNumFragmentedCarbons() method to make use of the 
#   specified number of backbone carbons in each fragment.
#
################################################################################

use strict;
use warnings;

use parent qw(FluxY_Lib::MS::CompoundClass);   # Sets the parent class.


# List of the atoms found in the starch monomer and subsequently considerred for
# natural abundance.
";

   return $line;
}


################################################################################
# Subroutine: GetHeader2
################################################################################
sub GetHeader2 {
   my $line = "
# Hash of compound data, (first two array elements are required).
# 1. The compound names (Soluable Metabolites), in lower case (for standard comparison).
# 2. The atom count for the soluable metabolite.
#    - Each of the atom counts is an array of the number of each corresponding
#    atom in the atomList, i.e. C, H, 0, N, S, Si and P.
# 3. The starting and ending position of the labeled element in the fragment backbone.
# 4. The number of labeled atoms in the backbone of the unfragmented compound.
# 5. The number of carbon atoms in the backbone of the fragmented compound.
# NOTE: The 3'rd field is used to support Generate.pm child classes.
# NOTE: The 4'th field is used to support Generate13C.pm (LM - cumomers).
# NOTE: The 5'th field is used to support the OBM correction.
my %compounds = (
";
   return $line;
}


################################################################################
# Subroutine: GetMethods
################################################################################
sub GetMethods {
   my $line = '
################################################################################
# Class constructor
#
# Used to instantiate an object for this class.
#
################################################################################
sub new {
   my ($class) = @_;
   
   # Call the constructor of the parent class (CompoundClass).
   my $self = $class->SUPER::new($className, \%compounds, \@atomList, $lElement);
   
   bless $self, $class;

   return $self;
}


############################
#   Overridden  methods.   #
############################

################################################################################
# Subroutine: GetNumLabeledElement
#
# Returns the number of labeled backbone atoms for the specified (unfragmented)
# compound.
#
# Overridden to use the number of labeled backbone atoms specified in each
# compound array.
#
################################################################################
sub GetNumLabeledElement {
   my ($self, $compound, $element) = @_;

   if ( !($self->CheckCompound($compound)) ) { return; }
   
   return ${ $self->{_compounds} }{$compound}[3];
}


################################################################################
# Subroutine: GetNumFragmentedLabeledElement
#
# Returns the number of fragmented backbone atoms for the labeled element of the
# specified compound and fragment.
# - If the element is not found in the atom list, returns the flag: -1.
#
# Overridden to use the labeled backbone specified for each fragment.
#
################################################################################
sub GetNumFragmentedLabeledElement {
   my ($self, $compound) = @_;

   if ( !($self->CheckCompound($compound)) ) { return; }
   
   my ($first,$last) = @{${ $self->{_compounds} }{$compound}[2]};

   return ($last - $first + 1);
}


################################################################################
# Subroutine: GetNumFragmentedCarbons
#
# Returns the number of backbone carbon atoms for the specified compound and
# fragment. This is used for the OBM correction.
#
# Overridden to use the labeled backbone specified for each fragment.
#
################################################################################
sub GetNumFragmentedCarbons{
   my ($self, $compound) = @_;

   if ( !($self->CheckCompound($compound)) ) { return; }
   
   return ${ $self->{_compounds} }{$compound}[4];
}


################################################################################
# Subroutine: GetLabeledPositionString
#
# Returns the relative positional string of the labeled element for the given
# compound.
#
# Overridden to use the first and last position of the labeled element in the 
# fragment bacbone, as specified in each compound array.
#
################################################################################
sub GetLabeledPositionString {
   my ($self, $compound) = @_;

   if ( !($self->CheckCompound($compound)) ) { return; }
   
   my ($first,$last) = @{${ $self->{_compounds} }{$compound}[2]};
	   
   return($self->GetPositionString($first, $last));
}


################################################################################
# Subroutine: PrintInfoTable
#
# This method generates a file containing an information table for the specific
# compound, including its atomic make up, mass, labeled backbone and full name.
#
# Overridden to use the first and last position of the labeled element in the 
# fragment bacbone, as specified in each compound array.
#
################################################################################
sub PrintInfoTable{
   my ($self) = @_;

   open (FILE, ">" . $printFile) or FileSystemError(900, $printFile, $!);

   print FILE $self->GetDataType . " Data Table:\n\n\t";

   print FILE "\t" . join("\t", $self->GetAtomList) . "\tMass\tC-Backbone\tFull Name\n";
  
   foreach my $compound ($self->GetCompoundList) {   
      my $fullName = $self->GetCompoundName($compound);
      my @totAtoms = $self->GetTotalAtomCount($compound);
      my $mass     = $self->GetMass($compound);
		my ($first, $last) = @{${ $self->{_compounds} }{$compound}[2]};

      print FILE $compound . "\t\t" .  join("\t", @totAtoms) . "\t" . $mass . "\t" . $first . "-" . $last . "\t" . $fullName . "\n";
   }
   
   close(FILE)                 or FileSystemError(901, $printFile, $!);
}

1;';

   return $line;
}


#################################################################################
# Subroutine: ImportError
#
# Prints out appropriate error message and terminates the program.
#
################################################################################
sub ImportError {
   my ($errorCode, @values) = @_;
   
   print "\n\n\tError: " . $errorCode . " - called by:\n";

   my $i = 0;
   my @calledBy = ();
   while ( @calledBy = caller($i++) ) {
      print "\tLine " . $calledBy[2] . " - " . $calledBy[3] . "\n";
   }
	
   print "\nInvalid Value.\n\n\t";
   
   if ($errorCode == 880) {
      print "The specified labeling element " . $values[0] . ", is not a valid element.";
   } elsif ($errorCode == 881) {
      print "One or more of the elements specified in the header row,\n\n\t" . 
            join("\t", @values) . "\n\n\tare invalid.";
   } elsif ($errorCode == 885) {
      print "The key value provided in row " . $values[0] . ", '" . $values[1] . "', is invalid. The first character\n\tmust be a letter.";
   } elsif ($errorCode == 886) {
      print "The entry for the Backbone column on row " . $values[0] . " is incorrect.\n\n" .
            "\tThe correct format specifies the range of the backbone carbons in the\n" .
            "\tfragment with the first value representing the starting position, the\n" .
            "\tsecond value the ending position and a hyphen separating the two values.";
   } elsif ($errorCode == 887) {
      print "The entry for the Position-LE column, " . join("-", @values[1,2]) . ", on row " . $values[0] . " is incorrect.\n\n" .
            "\tThe correct format specifies the range of the backbone carbons in the\n" .
            "\tfragment with the first value representing the starting position, the\n" .
            "\tsecond value the ending position and a hyphen separating the two values.";
   } elsif ($errorCode == 888) {
      print "The entry for the Num-LE, " . $values[1] . ", and Position-LE, " . join("-", @values[2,3]) . ", columns on row " . $values[0] . "\n\tare inconsistent.\n\n" .
            "\tThe total number of labeled atoms in the unfragmented backbone must be\n" .
            "\tequal to or larger than the ending position of the fragment backbone.";
   } elsif ($errorCode == 888) {
      print "The entry for the Num-C, " . $values[1] . ", and the total carbon, " . $values[2] . ", columns on row " . $values[0] . "\n\tare inconsistent.\n\n" .
            "\tThe total number of fragmented backbone carbons can not be more than\n" .
            "\tthe total number of carbons in the fragment.";
   }

   print "\n\n";
   
   exit -1;
}


1;